<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
<title>Source code</title>
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
</head>
<body>
<div class="sourceContainer">
<pre><span class="sourceLineNo">001</span>/*<a name="line.1"></a>
<span class="sourceLineNo">002</span> * Licensed to the Apache Software Foundation (ASF) under one or more<a name="line.2"></a>
<span class="sourceLineNo">003</span> * contributor license agreements.  See the NOTICE file distributed with<a name="line.3"></a>
<span class="sourceLineNo">004</span> * this work for additional information regarding copyright ownership.<a name="line.4"></a>
<span class="sourceLineNo">005</span> * The ASF licenses this file to You under the Apache License, Version 2.0<a name="line.5"></a>
<span class="sourceLineNo">006</span> * (the "License"); you may not use this file except in compliance with<a name="line.6"></a>
<span class="sourceLineNo">007</span> * the License.  You may obtain a copy of the License at<a name="line.7"></a>
<span class="sourceLineNo">008</span> *<a name="line.8"></a>
<span class="sourceLineNo">009</span> *      http://www.apache.org/licenses/LICENSE-2.0<a name="line.9"></a>
<span class="sourceLineNo">010</span> *<a name="line.10"></a>
<span class="sourceLineNo">011</span> * Unless required by applicable law or agreed to in writing, software<a name="line.11"></a>
<span class="sourceLineNo">012</span> * distributed under the License is distributed on an "AS IS" BASIS,<a name="line.12"></a>
<span class="sourceLineNo">013</span> * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.<a name="line.13"></a>
<span class="sourceLineNo">014</span> * See the License for the specific language governing permissions and<a name="line.14"></a>
<span class="sourceLineNo">015</span> * limitations under the License.<a name="line.15"></a>
<span class="sourceLineNo">016</span> */<a name="line.16"></a>
<span class="sourceLineNo">017</span><a name="line.17"></a>
<span class="sourceLineNo">018</span>package org.apache.commons.dbcp2;<a name="line.18"></a>
<span class="sourceLineNo">019</span><a name="line.19"></a>
<span class="sourceLineNo">020</span>import java.sql.PreparedStatement;<a name="line.20"></a>
<span class="sourceLineNo">021</span>import java.sql.ResultSet;<a name="line.21"></a>
<span class="sourceLineNo">022</span>import java.sql.SQLException;<a name="line.22"></a>
<span class="sourceLineNo">023</span>import java.util.ArrayList;<a name="line.23"></a>
<span class="sourceLineNo">024</span>import java.util.List;<a name="line.24"></a>
<span class="sourceLineNo">025</span><a name="line.25"></a>
<span class="sourceLineNo">026</span>import org.apache.commons.pool2.KeyedObjectPool;<a name="line.26"></a>
<span class="sourceLineNo">027</span><a name="line.27"></a>
<span class="sourceLineNo">028</span>/**<a name="line.28"></a>
<span class="sourceLineNo">029</span> * A {@link DelegatingPreparedStatement} that cooperates with {@link PoolingConnection} to implement a pool of<a name="line.29"></a>
<span class="sourceLineNo">030</span> * {@link PreparedStatement}s.<a name="line.30"></a>
<span class="sourceLineNo">031</span> * &lt;p&gt;<a name="line.31"></a>
<span class="sourceLineNo">032</span> * My {@link #close} method returns me to my containing pool. (See {@link PoolingConnection}.)<a name="line.32"></a>
<span class="sourceLineNo">033</span> * &lt;/p&gt;<a name="line.33"></a>
<span class="sourceLineNo">034</span> *<a name="line.34"></a>
<span class="sourceLineNo">035</span> * @param &lt;K&gt;<a name="line.35"></a>
<span class="sourceLineNo">036</span> *            the key type<a name="line.36"></a>
<span class="sourceLineNo">037</span> *<a name="line.37"></a>
<span class="sourceLineNo">038</span> * @see PoolingConnection<a name="line.38"></a>
<span class="sourceLineNo">039</span> * @since 2.0<a name="line.39"></a>
<span class="sourceLineNo">040</span> */<a name="line.40"></a>
<span class="sourceLineNo">041</span>public class PoolablePreparedStatement&lt;K&gt; extends DelegatingPreparedStatement {<a name="line.41"></a>
<span class="sourceLineNo">042</span><a name="line.42"></a>
<span class="sourceLineNo">043</span>    /**<a name="line.43"></a>
<span class="sourceLineNo">044</span>     * The {@link KeyedObjectPool} from which I was obtained.<a name="line.44"></a>
<span class="sourceLineNo">045</span>     */<a name="line.45"></a>
<span class="sourceLineNo">046</span>    private final KeyedObjectPool&lt;K, PoolablePreparedStatement&lt;K&gt;&gt; pool;<a name="line.46"></a>
<span class="sourceLineNo">047</span><a name="line.47"></a>
<span class="sourceLineNo">048</span>    /**<a name="line.48"></a>
<span class="sourceLineNo">049</span>     * My "key" as used by {@link KeyedObjectPool}.<a name="line.49"></a>
<span class="sourceLineNo">050</span>     */<a name="line.50"></a>
<span class="sourceLineNo">051</span>    private final K key;<a name="line.51"></a>
<span class="sourceLineNo">052</span><a name="line.52"></a>
<span class="sourceLineNo">053</span>    private volatile boolean batchAdded = false;<a name="line.53"></a>
<span class="sourceLineNo">054</span><a name="line.54"></a>
<span class="sourceLineNo">055</span>    /**<a name="line.55"></a>
<span class="sourceLineNo">056</span>     * Constructor.<a name="line.56"></a>
<span class="sourceLineNo">057</span>     *<a name="line.57"></a>
<span class="sourceLineNo">058</span>     * @param stmt<a name="line.58"></a>
<span class="sourceLineNo">059</span>     *            my underlying {@link PreparedStatement}<a name="line.59"></a>
<span class="sourceLineNo">060</span>     * @param key<a name="line.60"></a>
<span class="sourceLineNo">061</span>     *            my key" as used by {@link KeyedObjectPool}<a name="line.61"></a>
<span class="sourceLineNo">062</span>     * @param pool<a name="line.62"></a>
<span class="sourceLineNo">063</span>     *            the {@link KeyedObjectPool} from which I was obtained.<a name="line.63"></a>
<span class="sourceLineNo">064</span>     * @param conn<a name="line.64"></a>
<span class="sourceLineNo">065</span>     *            the {@link java.sql.Connection Connection} from which I was created<a name="line.65"></a>
<span class="sourceLineNo">066</span>     */<a name="line.66"></a>
<span class="sourceLineNo">067</span>    public PoolablePreparedStatement(final PreparedStatement stmt, final K key,<a name="line.67"></a>
<span class="sourceLineNo">068</span>            final KeyedObjectPool&lt;K, PoolablePreparedStatement&lt;K&gt;&gt; pool, final DelegatingConnection&lt;?&gt; conn) {<a name="line.68"></a>
<span class="sourceLineNo">069</span>        super(conn, stmt);<a name="line.69"></a>
<span class="sourceLineNo">070</span>        this.pool = pool;<a name="line.70"></a>
<span class="sourceLineNo">071</span>        this.key = key;<a name="line.71"></a>
<span class="sourceLineNo">072</span><a name="line.72"></a>
<span class="sourceLineNo">073</span>        // Remove from trace now because this statement will be<a name="line.73"></a>
<span class="sourceLineNo">074</span>        // added by the activate method.<a name="line.74"></a>
<span class="sourceLineNo">075</span>        removeThisTrace(getConnectionInternal());<a name="line.75"></a>
<span class="sourceLineNo">076</span>    }<a name="line.76"></a>
<span class="sourceLineNo">077</span><a name="line.77"></a>
<span class="sourceLineNo">078</span>    /**<a name="line.78"></a>
<span class="sourceLineNo">079</span>     * Add batch.<a name="line.79"></a>
<span class="sourceLineNo">080</span>     */<a name="line.80"></a>
<span class="sourceLineNo">081</span>    @Override<a name="line.81"></a>
<span class="sourceLineNo">082</span>    public void addBatch() throws SQLException {<a name="line.82"></a>
<span class="sourceLineNo">083</span>        super.addBatch();<a name="line.83"></a>
<span class="sourceLineNo">084</span>        batchAdded = true;<a name="line.84"></a>
<span class="sourceLineNo">085</span>    }<a name="line.85"></a>
<span class="sourceLineNo">086</span><a name="line.86"></a>
<span class="sourceLineNo">087</span>    /**<a name="line.87"></a>
<span class="sourceLineNo">088</span>     * Clear Batch.<a name="line.88"></a>
<span class="sourceLineNo">089</span>     */<a name="line.89"></a>
<span class="sourceLineNo">090</span>    @Override<a name="line.90"></a>
<span class="sourceLineNo">091</span>    public void clearBatch() throws SQLException {<a name="line.91"></a>
<span class="sourceLineNo">092</span>        batchAdded = false;<a name="line.92"></a>
<span class="sourceLineNo">093</span>        super.clearBatch();<a name="line.93"></a>
<span class="sourceLineNo">094</span>    }<a name="line.94"></a>
<span class="sourceLineNo">095</span><a name="line.95"></a>
<span class="sourceLineNo">096</span>    /**<a name="line.96"></a>
<span class="sourceLineNo">097</span>     * Return me to my pool.<a name="line.97"></a>
<span class="sourceLineNo">098</span>     */<a name="line.98"></a>
<span class="sourceLineNo">099</span>    @Override<a name="line.99"></a>
<span class="sourceLineNo">100</span>    public void close() throws SQLException {<a name="line.100"></a>
<span class="sourceLineNo">101</span>        // calling close twice should have no effect<a name="line.101"></a>
<span class="sourceLineNo">102</span>        if (!isClosed()) {<a name="line.102"></a>
<span class="sourceLineNo">103</span>            try {<a name="line.103"></a>
<span class="sourceLineNo">104</span>                pool.returnObject(key, this);<a name="line.104"></a>
<span class="sourceLineNo">105</span>            } catch (final SQLException e) {<a name="line.105"></a>
<span class="sourceLineNo">106</span>                throw e;<a name="line.106"></a>
<span class="sourceLineNo">107</span>            } catch (final RuntimeException e) {<a name="line.107"></a>
<span class="sourceLineNo">108</span>                throw e;<a name="line.108"></a>
<span class="sourceLineNo">109</span>            } catch (final Exception e) {<a name="line.109"></a>
<span class="sourceLineNo">110</span>                throw new SQLException("Cannot close preparedstatement (return to pool failed)", e);<a name="line.110"></a>
<span class="sourceLineNo">111</span>            }<a name="line.111"></a>
<span class="sourceLineNo">112</span>        }<a name="line.112"></a>
<span class="sourceLineNo">113</span>    }<a name="line.113"></a>
<span class="sourceLineNo">114</span><a name="line.114"></a>
<span class="sourceLineNo">115</span>    @Override<a name="line.115"></a>
<span class="sourceLineNo">116</span>    public void activate() throws SQLException {<a name="line.116"></a>
<span class="sourceLineNo">117</span>        setClosedInternal(false);<a name="line.117"></a>
<span class="sourceLineNo">118</span>        if (getConnectionInternal() != null) {<a name="line.118"></a>
<span class="sourceLineNo">119</span>            getConnectionInternal().addTrace(this);<a name="line.119"></a>
<span class="sourceLineNo">120</span>        }<a name="line.120"></a>
<span class="sourceLineNo">121</span>        super.activate();<a name="line.121"></a>
<span class="sourceLineNo">122</span>    }<a name="line.122"></a>
<span class="sourceLineNo">123</span><a name="line.123"></a>
<span class="sourceLineNo">124</span>    @Override<a name="line.124"></a>
<span class="sourceLineNo">125</span>    public void passivate() throws SQLException {<a name="line.125"></a>
<span class="sourceLineNo">126</span>        // DBCP-372. clearBatch with throw an exception if called when the<a name="line.126"></a>
<span class="sourceLineNo">127</span>        // connection is marked as closed.<a name="line.127"></a>
<span class="sourceLineNo">128</span>        if (batchAdded) {<a name="line.128"></a>
<span class="sourceLineNo">129</span>            clearBatch();<a name="line.129"></a>
<span class="sourceLineNo">130</span>        }<a name="line.130"></a>
<span class="sourceLineNo">131</span>        setClosedInternal(true);<a name="line.131"></a>
<span class="sourceLineNo">132</span>        removeThisTrace(getConnectionInternal());<a name="line.132"></a>
<span class="sourceLineNo">133</span><a name="line.133"></a>
<span class="sourceLineNo">134</span>        // The JDBC spec requires that a statement closes any open<a name="line.134"></a>
<span class="sourceLineNo">135</span>        // ResultSet's when it is closed.<a name="line.135"></a>
<span class="sourceLineNo">136</span>        // FIXME The PreparedStatement we're wrapping should handle this for us.<a name="line.136"></a>
<span class="sourceLineNo">137</span>        // See bug 17301 for what could happen when ResultSets are closed twice.<a name="line.137"></a>
<span class="sourceLineNo">138</span>        final List&lt;AbandonedTrace&gt; resultSetList = getTrace();<a name="line.138"></a>
<span class="sourceLineNo">139</span>        if (resultSetList != null) {<a name="line.139"></a>
<span class="sourceLineNo">140</span>            final List&lt;Exception&gt; thrownList = new ArrayList&lt;&gt;();<a name="line.140"></a>
<span class="sourceLineNo">141</span>            final ResultSet[] resultSets = resultSetList.toArray(new ResultSet[resultSetList.size()]);<a name="line.141"></a>
<span class="sourceLineNo">142</span>            for (final ResultSet resultSet : resultSets) {<a name="line.142"></a>
<span class="sourceLineNo">143</span>                if (resultSet != null) {<a name="line.143"></a>
<span class="sourceLineNo">144</span>                    try {<a name="line.144"></a>
<span class="sourceLineNo">145</span>                        resultSet.close();<a name="line.145"></a>
<span class="sourceLineNo">146</span>                    } catch (Exception e) {<a name="line.146"></a>
<span class="sourceLineNo">147</span>                        thrownList.add(e);<a name="line.147"></a>
<span class="sourceLineNo">148</span>                    }<a name="line.148"></a>
<span class="sourceLineNo">149</span>                }<a name="line.149"></a>
<span class="sourceLineNo">150</span>            }<a name="line.150"></a>
<span class="sourceLineNo">151</span>            clearTrace();<a name="line.151"></a>
<span class="sourceLineNo">152</span>            if (!thrownList.isEmpty()) {<a name="line.152"></a>
<span class="sourceLineNo">153</span>                throw new SQLExceptionList(thrownList);<a name="line.153"></a>
<span class="sourceLineNo">154</span>            }<a name="line.154"></a>
<span class="sourceLineNo">155</span>        }<a name="line.155"></a>
<span class="sourceLineNo">156</span><a name="line.156"></a>
<span class="sourceLineNo">157</span>        super.passivate();<a name="line.157"></a>
<span class="sourceLineNo">158</span>    }<a name="line.158"></a>
<span class="sourceLineNo">159</span>}<a name="line.159"></a>




























































</pre>
</div>
</body>
</html>
